function MinArch:EventMain(event, ...)
	if (event == "CURRENCY_DISPLAY_UPDATE" and MAHideNext == true) then
		MinArch:MaineEventHideAfterDigsite();		
	elseif (event == "SKILL_LINES_CHANGED") then
		MinArch:UpdateArchaeologySkillBar();		
	elseif (event == "ARTIFACT_DIG_SITE_UPDATED" and MAOptions['HideAfterDigsite'] == true) then
		MAHideNext = true;
	elseif (event == "ARTIFACT_COMPLETE" and MAHideNext == true and MAOptions['WaitForSolve'] == true) then
		MinArch:HideMain();
		MAHideNext = false;
		RequestArtifactCompletionHistory();
	elseif (event == "PLAYER_ALIVE" or event == "ARTIFACT_COMPLETE") then
		RequestArtifactCompletionHistory();
	elseif (event == "ADDON_LOADED" and MinArch ~= nil and MAIsReady ~= true) then
		MinArch:MainEventAddonLoaded();		
	end	
	
	if (MAIsReady == true) then
		MinArch:UpdateMain();
	end
end

function MinArch:EventHist(event, ...)
	if (event == "ARTIFACT_HISTORY_READY") then
		if (IsArtifactCompletionHistoryAvailable()) then
			for i = 1, 10 do
				MinArch:LoadItemDetails(i);
				MinArch:GetHistory(i);
			end
			MinArch:CreateHistoryList(MAOptions['CurrentHistPage']);
			MinArch:CreateHistoryList(MAOptions['CurrentHistPage']);
		end
	end
end

function MinArch:EventDigsites(event, ...)
	if (event == "UNIT_SPELLCAST_SENT") then
		local unit, spellname, rank, desc = ...;
		
		if (unit == "player") then
			for index, artifact in pairs(MinArch['artifacts']) do
				if (desc ~= nil and artifact['race'] ~= nil ) then
					local hasRace = string.find(tostring(desc), tostring(artifact['race']));
						
					if (hasRace ~= nil) then
						MinArch:UpdateActiveDigSitesRace(tostring(artifact['race']));
						
						if (MADigsites:IsVisible()) then
							local ContID = GetCurrentMapContinent();
							MinArch:CreateDigSitesList(ContID);
							MinArch:CreateDigSitesList(ContID);
						end
					end
				end			
			end	
			
			
		end
	elseif (event == "WORLD_MAP_UPDATE" and MAIsReady == true) then		
		MinArch:ShowRaceIconsOnMap();
	else
		MinArch:UpdateActiveDigSites();
		local ContID = GetCurrentMapContinent();
		MinArch:CreateDigSitesList(ContID);
		MinArch:CreateDigSitesList(ContID);
	end
end

function MinArch:MaineEventHideAfterDigsite()
	if (MAOptions['WaitForSolve'] == true) then
		local wait = false;
		for i=1,10 do
			MinArch:UpdateArtifact(i);
			if (MinArch['artifacts'][i]['canSolve']) then
				wait = true;
			end
		end

		if (wait == false) then
			MinArch:HideMain();
			MAHideNext = false;
		end
	else
		MinArch:HideMain();
		MAHideNext = false;
	end
end

function MinArch:MainEventAddonLoaded()
	-- Apply Settins/SavedVariables
	if (MAOptions['MinimapPos'] ~= nil) then
		MinArch:MinimapButtonReposition();
	else
		MAOptions['MinimapPos'] = 45;
	end
	
	if (MAOptions['CurrentHistPage'] == nil) then
		MAOptions['CurrentHistPage'] = 1;
	end
		
	if (MAOptions['StartHidden'] == nil) then
		MAOptions['StartHidden'] = false;
	else
		if (MAOptions['StartHidden'] == true) then
			MinArch:HideMain();
		end
	end
		
	if (MAOptions['HideMain'] == nil) then
		MinArch:ShowMain();
	else
		if (MAOptions['HideMain'] == true) then
			MinArch:HideMain();
		end
	end
		
	if (MAOptions['HideMinimap'] == nil) then
		MAOptions['HideMinimap'] = false;
	else
		if (MAOptions['HideMinimap'] == true) then
			MinArchMinimapButton:Hide();
		end
	end
		
	if (MAOptions['DisableSound'] == nil) then
		MAOptions['DisableSound'] = false;
	end

	if (MAOptions['HideAfterDigsite'] == nil) then
		MAOptions['HideAfterDigsite'] = false;
	end	
		
	if (MAOptions['WaitForSolve'] == nil) then
		MAOptions['WaitForSolve'] = false;
	end	
		
	if (MAOptions['FrameScale'] == nil) then
		MAOptions['FrameScale'] = 100;
	end
		
	for i=0,10 do
		if (MAOptions['ABOptions'][i] == nil) then
			MAOptions['ABOptions'][i] = {}; 
			MAOptions['ABOptions'][i]['Hide'] = false;
			MAOptions['ABOptions'][i]['Cap'] = false;
			MAOptions['ABOptions'][i]['AlwaysUseKeystone'] = false;
		end
	end
	
	MinArch:CommonFrameScale(MAOptions['FrameScale']);
	MAIsReady = true;
		
	ChatFrame1:AddMessage("Minimal Archaeology Loaded!");
end